/* $Id$ */
/*
 * Copyright (C) 2008-2012 Teluu Inc. (http://www.teluu.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef __PJSUA2_DOXYGEN_HPP__
#define __PJSUA2_DOXYGEN_HPP__

/**
 * @file pjsua2/doxygen.hpp
 * @brief PJSUA2 Doxygen documentation
 */

/**
 * @defgroup PJSUA2 PJSUA2: High Level Object Oriented PJSUA API
 * @{
 * The PJSUA2 API is a new, high-level, object-oriented API that is built
 * on top of PJSUA-LIB API. The PJSUA2 API is implemented with C++ and
 * can be used from other high level languages such as Java and Python.
 * Thanks to <A HREF="http://www.swig.org">SWIG</A>, the API can potentially
 * be used in other high level or scripting languages where SWIG binding is
 * available, such as C#, Perl, PHP, Ruby, and Tcl.
 *
 * This page mostly contains the reference documentation of the API. For
 * more guide on the API, please see the PJSUA2 wiki page:
 * http://trac.pjsip.org/repos/wiki/pjsua2_API
 * @}
 */

/**
 * @defgroup PJSUA2_Ref API Reference
 * @ingroup PJSUA2
 */



/**
 * @}  PJSUA2_CFG
 */

#endif	/* __PJSUA2_DOXYGEN_HPP__ */
